# 备份还原
## 概 述
备份还原用于对系统或用户数据进行备份和还原。该工具支持新建备份点，也支持在某个备份点上进行增量备份；支持将系统还原到某次备份时的状态，或者在保留用户数据的情况下进行还原。

备份还原有2种模式：常规模式、Grub备份还原。

<br>

## 常规模式
### 系统备份

![图 1 系统备份-big](image/1.png)


- **系统备份** —— 将除/backup、/media、/run、/proc、/dev、/sys、/cdrom、/mnt等目录外的整个文件系统中的数据(包含用户数据)进行备份。

单击 “开始备份”按钮，进入选择备份位置页面，可以选择备份到本地备份分区或移动设备，也可以选择备份到本机非备份分区中，但不能受到保护。如图2所示。

![图 2 系统备份位置选择 -big](image/2.png)

单击“下一步”按钮，进入环境检测界面。检测诸如备份空间是否充足等，检测完成会展示检测结果。见3、4两图。
 
![图 3 环境检测-big](image/3.png)
![图 4 检测通过-big](image/4.png)

单击“下一步”按钮，进入备份准备界面。在此界面可以定义备份点名称，并对备份名称进行唯一性校验。如图5所示。

![图 5 备份准备 -big](image/5.png)

定义好备份名称后，单击“下一步”按钮，进入备份中界面，正式进行备份。如图6所示。

![图 6 系统备份中-big](image/6.png)

备份过程中可以单击“取消”按钮，取消备份操作。
备份完成后，进入备份完成界面，展示备份结果。如图7所示。

![图 7 系统备份完成-big](image/7.png)

单击“返回首页”按钮，单击首页的右下角的“备份管理”标签，弹出系统备份管理窗口，可以看到刚刚的系统备份。如图8所示。

![图 8 系统备份管理-big](image/8.png)

可以在备份管理页面，选择某个备份点，单击“删除”按钮，删除相应的备份点。

### 系统还原
“系统还原” 可将系统还原到以前一个备份时的状态。注意：系统还原时同样会将用户数据进行还原，为防止用户数据丢失，可以先用数据备份将重要的用户数据进行备份；若需要保留完整的用户数据，也可以选择系统还原首页中的“保留用户数据”复选框后再还原。

![图 9 系统还原-big](image/9.png)

单击“开始还原”按钮，会弹出系统备份列表窗口，如图10所示。

![图 10 选择还原点-big](image/10.png)

选择相应的备份点，单击“确定”按钮，进入系统还原的环境检测界面。如图11所示。

![图 11 系统还原环境检测-big](image/11.png)

检测成功后，单击“下一步”按钮，进入还原页面，开始进行系统还原。如图12所示。

![图 12 系统还原中-big](image/12.png)

还原成功后，系统自动重启。

### 数据备份与数据还原
- **数据备份** —— 对用户指定的目录或文件进行备份（限定为家目录/home/xxx、/data或/data/usershare目录下的数据），操作与系统备份相似。可以新建备份，也可以对现有备份进行更新。如图13所示。

![图 13 数据备份主界面-big](image/13.png)

注：``、$()、;、&、|等可以包含并执行系统命令或用于连续执行系统命令的符号加入黑名单，在备份前对要备份的目录名称进行判断，若包含有黑名单中的符号，则不允许进行备份。

单击“开始备份”按钮，进入备份路径选择页面。如图14所示。

![图 14 数据备份路径选择-big](image/14.png)

或单击“备份更新”按钮，弹出数据备份列表窗口，选择已经存在的某个备份点进行更新。如图15所示。

![图 15 更新数据备份 -big](image/15.png)

选择好备份路径后，单击“下一步”按钮，进入环境检测-->备份准备-->备份中-->备份完成等环节，和系统备份类似。
数据备份首页右下角的“备份管理”，可用来查看数据备份状态，删除无效备份。
- **数据增量备份** —— 在某个数据备份的基础上，更新备份点的数据。
- **数据还原** —— 还原到某个数据备份的状态，功能与系统还原相似。

![图 16 数据还原主界面-big](image/16.png)

### 操作日志
记录了在备份还原上的所有备份、还原、删除操作，主界面如图17所示。

![图 17 操作日志主界面-big](image/17.png)

### Ghost镜像
Ghost镜像安装，是指将一台机器上的系统生成一个镜像文件，然后使用该镜像文件来安装操作系统。要使用该功能，首先需要有一个本地系统备份。

#### 创建Ghost镜像
选择菜单“Ghost镜像”，如图18所示。

![图 18 Ghost镜像主界面-big](image/18.png)

单击“创建镜像”按钮后，会弹出当前所有本地系统备份的列表；用户选择一个备份点，点击“确定”后，进入镜像存储位置选择界面，可以选择本地或移动设备，如图19所示。

![图 19 Ghost镜像存储位置-big](image/19.png)

单击“下一步”按钮，进入环境检测页面，如图20所示。

![图 20 制作镜像环境检测-big](image/20.png)

检测成功后，单击“下一步”按钮，进入制作中界面，开始制作Ghost镜像。如图21所示。

![图 21 镜像制作中-big](image/21.png)

镜像文件名的格式为“主机名+体系架构+备份名称.kyimg”；其中，备份名称中去掉了某些符号。制作完成后，进入完成界面。如图22所示。
 
![图 22 Ghost镜像制作完成-big](image/22.png)

#### 安装Ghost镜像
1）把制作好的Ghost镜像（存在于“/ghost”目录下）拷贝到U盘等可移动存储设备。

2）进入Live系统后，接入可移动设备。

3）若设备没有自动挂载，可通过终端，手动将设备挂载到/mnt目录下：

“sudo mount /dev/sdb1 /mnt”

通常情况下，移动设备为/dev/sdb1，可使用命令“fdisk -l”查看。

4）双击安装图标，开始安装引导。在“安装方式”中选择“从Ghost镜像安装”，并找到移动设备中的Ghost镜像文件。后续步骤可参考“系统安装”部分。

Tips：如果制作镜像文件时带有数据分区，则在下一步“安装类型”中也要创建“数据分区”。

<br>

## Grub备份还原
1）开机启动系统时，在Grub菜单选择系统备份还原模式。注：仅支持系统安装时有备份分区的机器。

2）备份模式：系统立即开始备份，屏幕上会给出提示。

对于备份模式而言，等同于常规模式下的“系统备份”。如果备份还原分区没有足够空间，则无法成功备份。

3）还原模式：系统立即开始还原到最近一次的成功备份状态，屏幕上会给出提示。

对于还原模式而言，如果备份还原分区上没有一个成功的备份，则系统不能被还原。

<br>

## 常见问题
- 无法使用备份还原
在安装操作系统时，必须要选中“创建备份还原分区”，备份还原才能使用。
- 备份分区空间不足
备份分区（/backup）大小是安装系统时固定的，一般也不会太大，随着系统的使用量逐渐增大，会造成备份空间不足无法进行备份的情况。此时可以备份到移动设备上，不过备份速度会变慢。
建议系统只进行一个初装备份到备份分区，后面的系统备份都备份到移动设备上。比较重要的数据统一放到某个目录中，用数据备份功能进行备份。
